#!/usr/bin/perl

# makeana.pl (c) 2006 CMG Lee
# Perl script to create a sorted anagrams file (e.g. for Grabble)
# Create a text file (need not be sorted) with one word per line.
# Set $sourcefile and $targetfile as appropriate then run.
my $sourcefile="sowprack.txt";
my $targetfile="sowprack.ana";

my $sep = "\t";
my $index = 0; my $tick = 0;
my @lines; my @chars;
my $line; my $word; my $sorted;

# READ SOURCE FILE
print "Reading";
open (sourcefile, "$sourcefile");
# for each word...
while (chop($line = <sourcefile>) && $line ne "") {
 # convert to lower case
 $word = $line; $word =~ tr/[A-Z]/[a-z]/;
 # sort characters
 @chars = split(/ */, $word); @chars = sort @chars;
 $sorted = ""; foreach $char (@chars) { $sorted .= $char; }
 # store in record array
 $lines[$index++] = "$sorted$sep$word";
 if ($tick++ == 1e3) { print "."; $tick = 0; }
}
close sourcefile;

# SORT LINES BY SORTED CHARACTERS
print "\nSorting";
@lines = sort @lines;
$tick = 0;

# WRITE TO TARGET FILE
print "\nWriting";
open (targetfile, ">$targetfile");
$word = ""; # used to remove redundant words
foreach $line (@lines) {
 if ($line ne $word) { print targetfile "$line\n"; $word = $line; }
 if ($tick++ == 1e3) { print "."; $tick = 0; }
}
close targetfile;
print "\n";